//************************************************************************
//
//  (c) Copyright Cisco Systems Inc., All Rights Reserved.
//  All use, disclosure, and/or reproduction of this material is
//  prohibited unless authorized in writing.
//
//************************************************************************
Ext.define("HtmlGui.view.workspace.items.WSSceneView",{extend:"Ext.draw.Component",requires:["Ext.util.Point","Ext.util.Region","Ext.viewport.Viewport",],uses:["HtmlGui.view.workspace.items.WSSceneItem"],statics:{MIN_ZOOM:0.4,MAX_ZOOM:4},config:{autoScaleForScreenSize:false,itemId:"wssceneview",sceneWidth:2000,sceneHeight:2000,sceneBackground:{mode:"plain",color:"#FAFAFA"}},createSceneItem:function(a,b,e){var c=a;if(c.lastIndexOf(".")===-1){c="HtmlGui.view.workspace.items."+a}var d=Ext.create(c,Ext.merge({sceneView:this},b||{}));if(e){this.addSceneItem(d)}return d},addSceneItem:function(d){if(!(d instanceof HtmlGui.view.workspace.items.WSSceneItem)){AppLogger.warn("Only instances of WSSceneItem can be added to the scene view");return null}var c=d.getDrawLayerId();if(this.drawLayerIds.indexOf(c)==-1){AppLogger.warn("Item has belongs to unsupported layer: ",c);return null}var a=this.getSurface(c);var b=a.add(d);this.updateView();return b===d?d:null},removeAllSceneItems:function(){this.getItems().each(function(a){a.removeAll()});this.updateView()},removeSceneItem:function(d,c){if(!(d instanceof HtmlGui.view.workspace.items.WSSceneItem)){AppLogger.warn("Only instances of WSSceneItem can be removed from the scene view");return}var b=d.getDrawLayerId();if(this.drawLayerIds.indexOf(b)==-1){AppLogger.warn("Item has belongs to unsupported layer: ",b);return null}var a=this.getSurface(b);a.remove(d,!c);this.updateView()},getItemAt:function(b,a){var c=this.getItemsAt(b,a);return c.length>0?c[0]:null},getItemsAt:function(b,a){var c=function(d){return !d.attr.hidden&&d.containsPoint(b,a)};return this.findItems(c)},findItemsInRange:function(c,b,d,a){var e={l:0,r:0,t:0,b:0};var g;if(d>0){e.l=c;e.r=e.l+d}else{e.l=c+d;e.r=c}if(a>0){e.t=b;e.b=e.t+a}else{e.t=b+a;e.b=b}var f=function(h){var j=false;if(!h.attr.hidden){var i=h.getBBox();j=!((i.x>e.r)||((i.x+i.width)<e.l)||(i.y>e.b)||((i.y+i.height)<e.t))}return j};return this.findItems(f)},findItems:function(e,g,a){var c=a||[];var f=g||this;var b=this.get_sprite_items();for(var d=0;d<b.length;++d){var h=b[d];if(!h.htmlgui.isBackgroundItem&&e.call(g,h)){c.unshift(h)}}return c},findItem:function(c,e){var d=e||this;var a=this.get_sprite_items();for(var b=0;b<a.length;++b){var f=a[b];if(!f.htmlgui.isBackgroundItem&&c.call(e,f)){return f}}return null},moveViewBy:function(b,a){this.centerViewAt(this.viewCenter.x+b,this.viewCenter.y+a)},centerViewAt:function(c,b){this.viewCenter=Ext.util.Point.from({x:c,y:b});var a=this.make_view_rect(this.viewCenter);this.set_view_rect(a,false);return this.viewCenter},setViewZoom:function(a){this.viewZoom=this.clamp(a,this.self.MIN_ZOOM,this.self.MAX_ZOOM)/this.viewZoomDeviceSizeFactor;this.centerViewAt(this.viewCenter.x,this.viewCenter.y);return this.viewZoom*this.viewZoomDeviceSizeFactor},setViewZoomFromPinchScale:function(a){return this.viewZoom*this.viewZoomDeviceSizeFactor},getViewZoom:function(){return this.viewZoom},getViewZoomScaled:function(){return this.viewZoom*this.viewZoomDeviceSizeFactor},getViewRegion:function(){return this.get_view_rect()},setViewportSize:function(b,a){AppLogger.info("Resizing viewport to be",b,"by",a);this.viewportRect=Ext.util.Region.from({left:0,top:0,right:b,bottom:a});this.getItems().each(function(c){c.setRegion([0,0,b,a]);c.setDirty(true)});this.centerViewAt(this.viewCenter.x,this.viewCenter.y)},initViewport:function(){this.setViewportSize(this.element.getWidth(),this.element.getHeight());for(var b=0;b<this.drawLayerIds.length;++b){var a=this.getSurface(this.drawLayerIds[b]);a.svgElement.dom.setAttribute("width",this.element.getWidth());a.svgElement.dom.setAttribute("height",this.element.getHeight())}},refreshView:function(a){this.updateView(a,true)},updateView:function(b,a){this.pendingViewRefresh=this.pendingViewRefresh||a;if(b){AppLogger.warn("Forced scene view update");this.update_view()}else{if(!this.pendingViewUpdate){this.pendingViewUpdate=true;Ext.callback(function(){if(this.pendingViewUpdate){this.update_view()}},this,[],1)}}},mapSceneToScreen:function(c,a){var b=this.viewMatrix.transformPoint([c,a]);return Ext.util.Point.from({x:b[0],y:b[1]})},mapScreenToScene:function(c,a){var b=this.viewMatrixInverse.transformPoint([c,a]);return Ext.util.Point.from({x:b[0],y:b[1]})},getWorkspace:function(){if(this instanceof HtmlGui.view.workspace.Workspace){return this}else{if(this.getParent() instanceof HtmlGui.view.workspace.Workspace){return this.getParent()}}return null},markDrawLayerDirty:function(a){if(this.drawLayerIds.indexOf(a)!=-1){this.getSurface(a).setDirty(true)}},initDrawLayers:function(b){this.drawLayerIds=b;for(var a=0;a<this.drawLayerIds.length;++a){this.getSurface(this.drawLayerIds[a])}},initialize:function(){this.callParent(arguments);Ext.draw.Component.prototype.engine="Ext.draw.engine.Svg";AppLogger.info("Initializing WSSceneView...");if(this.getAutoScaleForScreenSize()){this.calcViewZoomDeviceSizeFactor();AppLogger.info("Initial size scale: "+this.viewZoomDeviceSizeFactor);this.viewZoomDeviceSizeFactor=getScreenPixelDensity()/this.viewZoomDeviceSizeFactor}this.sceneRect=Ext.util.Region.from({left:0,top:0,right:this.getSceneWidth(),bottom:this.getSceneHeight()});this.initView(0,0,1);this.on("resize",this.resizeHandler,this);AppLogger.info("... done")},calcViewZoomDeviceSizeFactor:function(){this.viewZoomDeviceSizeFactor=getScreenPixelDensity();if(window.matchMedia("(max-width:17cm)").matches){this.viewZoomDeviceSizeFactor=0.8}else{if(window.matchMedia("(max-width:20cm)").matches){this.viewZoomDeviceSizeFactor=0.9}else{this.viewZoomDeviceSizeFactor=1.3}}},resizeHandler:function(a){this.callParent(arguments);this.initViewport()},initView:function(d,b,c){var a=Ext.Viewport;this.viewCenter=Ext.util.Point.from({x:d,y:b});this.viewZoom=c;this.initViewport();this.centerViewAt(d,b);this.setViewZoom(c)},applySceneBackground:function(a){return a},updateSceneBackground:function(a){},get_view_rect:function(){return this.viewRect},get_sprite_items:function(){var b=this,a=[];this.getItems().each(function(c){a=a.concat(c.getItems().items)});return a},set_view_rect:function(b,e){var c=this.viewRect;this.viewRect=b.copy();if(!e){var a=0;var d=0;if(b.right-b.left<=this.getSceneWidth()){if(b.left<0){a=-b.left}else{if(b.right>this.getSceneWidth()){a=this.getSceneWidth()-b.right}}if(b.top<0){d=-b.top}else{if(b.bottom>this.getSceneHeight()){d=this.getSceneHeight()-b.bottom}}}else{a=-b.left;d=-b.top}if(a||d){this.viewRect.translateBy({x:a,y:d})}}this.viewCenter=Ext.util.Point.from({x:(this.viewRect.left+this.viewRect.right)*0.5,y:(this.viewRect.top+this.viewRect.bottom)*0.5});this.update_view_matrix();this.fireEvent("viewRegionChanged",this.viewRect,c?c:this.viewRect);return this.viewRect},make_view_rect:function(c,b){var d=c;var h=b||this.viewZoom;var a=this.viewportRect.getSize();var e=1/Math.sqrt(h)*0.5;var f=a.width*e;var g=a.height*e;return Ext.util.Region.from({left:d.x-f,top:d.y-g,right:d.x+f,bottom:d.y+g}).round()},matrix_toString:function(a){return[a.getXX(),a.getXY(),a.getYX(),a.getYY(),a.getDX(),a.getDY()].join(",")},update_view_matrix:function(){this.viewMatrix=Ext.draw.Matrix.createPanZoomFromTwoPair(this.viewRect.left,this.viewRect.top,this.viewRect.right,this.viewRect.bottom,this.viewportRect.left,this.viewportRect.top,this.viewportRect.right,this.viewportRect.bottom);this.viewMatrixInverse=this.viewMatrix.inverse();var a=this;this.getItems().each(function(b){b.matrix=a.viewMatrix.clone();b.inverseMatrix=a.viewMatrixInverse.clone();b.setDirty(true)});this.updateView()},update_view:function(){this.pendingViewUpdate=false;this.renderFrame();if(this.pendingViewRefresh){Ext.repaint();this.pendingViewRefresh=false;AppLogger.warn("WSSV %%% - Repainted whole page")}},clamp:function(b,c,a){return b<c?c:(b>a?a:b)},lerp:function(d,c,e,g){var f=d+(c-d)*e;if(g){return this.clamp(f,Math.min(d,c),Math.max(d,c))}return f},getByItemID:function(a){return this.findItem(function(b){return b.getId()==a})},getItemByUuid:function(a){return this.findItem(function(b){return(b.m_uuid&&(b.m_uuid==a))})},pendingViewUpdate:false,pendingViewRefresh:false,surface:null,sceneRect:null,viewCenter:null,viewZoom:1,viewZoomDeviceSizeFactor:1,viewRect:null,viewportRect:null,viewMatrix:null,viewMatrixInverse:null,sceneBackgroundItem:null,drawLayerIds:["main"]});